#pragma once

#include <a8/singleton.h>

namespace f8
{

    class JsonLog : public a8::Singleton<JsonLog>
    {
    private:
        JsonLog();
        friend class a8::Singleton<JsonLog>;

    public:
        ~JsonLog();

        void Init();
        void UnInit();

        void SetLogFileName(const std::string& filename);

        void AddLog(a8::XObject* logobj);

    private:
        void SaveToFileThreadProc();

    private:
        struct JsonLogImpl* impl_ = nullptr;
    };

}
